`timescale 1ns / 1ps
//////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer: 
// 
// Create Date:    16:20:19 05/17/2019 
// Design Name: 
// Module Name:    square_root_NR 
// Project Name: 
// Target Devices: 
// Tool versions: 
// Description: 
//
// Dependencies: 
//
// Revision: 
// Revision 0.01 - File Created
// Additional Comments: 
//
//////////////////////////////////////////////////////////////////////////////////
module square_root_NR(x,q,r);

input [7:0] x;
output [4:0] r;
output [3:0] q;

wire p_out,p_out1,p_out2,p_out3,p_out4,p_out5,p_out6,p_out7,p_out8,p_out9,p_out10,
p_out11,p_out12,p_out13,p_out14,p_out15;

wire co,co1,co2,co3,co4,co5,co6,co7,co8,co9,co10,
co11,co12;

wire d_ou1,d_out2,d_out3,d_out4,d_out5;
wire t1,t2,t3,t4,t5,t6,t7,t8,t9;
wire r1,r2,r3,r4,r5,r6,r7,r8,q1,q2,q3,q4;

cas m1(1'b1,1'b0,x[7],co,p_out,,t2,q1);
cas m2(p_out,1'b1,x[6],p_out1,p_out1,,t1,co);

cas m3(q1,1'b0,t2,co3,p_out2,d_out2,r1,q2);
cas m4(p_out2,p_out2,t1,co2,p_out3,d_out1,t5,co3);
cas m5(p_out3,~p_out3,x[5],co1,p_out4,,t4,co2);
cas m6(p_out4,1'b1,x[4],p_out5,p_out5,,t3,co1);

cas m7(q2,d_out2,t5,co7,p_out6,d_out5,r2,q3);
cas m8(p_out6,d_out1,t4,co6,p_out7,d_out4,t10,co7);
cas m9(p_out7,p_out7,t3,co5,p_out8,d_out3,t9,co6);
cas m10(p_out8,~p_out8,x[3],co4,p_out9,,t8,co5);
cas m11(p_out9,1'b1,x[2],p_out10,p_out10,,t7,co4);

cas m12(q3,d_out5,t10,co12,p_out11,,r3,q4);
cas m13(p_out11,d_out4,t9,co11,p_out12,,r4,co12);
cas m14(p_out12,d_out3,t8,co10,p_out13,,r5,co11);
cas m15(p_out13,p_out13,t7,co9,p_out14,,r6,co10);
cas m16(p_out14,~p_out14,x[1],co8,p_out15,,r7,co9);
cas m17(p_out15,1'b1,x[0],p_out16,p_out16,,r8,co8);

assign q = {q1,q2,q3,q4};
assign r = {r4,r5,r6,r7,r8};
endmodule
